using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Reflection;
using System.Threading;
using System.Runtime.InteropServices;
using NdisMonitor;

namespace NdisMonitor
{
	/// <summary>
	/// Summary description for ctrlForm.
	/// </summary>
	public class ctrlForm : System.Windows.Forms.Form, IMessageFilter
	{
		private System.Windows.Forms.MainMenu ctrlMenu;
		private System.Windows.Forms.ToolBar ctrlToolbar;
		private System.Windows.Forms.MenuItem miFileMenu;
		private System.Windows.Forms.ToolBarButton ctrlStart;
		private System.Windows.Forms.ImageList toolbarImages;
		private System.Windows.Forms.ToolBarButton ctrlStop;
		private System.Windows.Forms.ToolBarButton ctrlOpen;
		private System.Windows.Forms.ToolBarButton ctrlSave;
		private System.Windows.Forms.ToolBarButton ctrlAbout;
		private System.Windows.Forms.ToolBarButton sep2;
		private System.Windows.Forms.ToolBarButton sep3;
		private System.Windows.Forms.ToolBarButton sep1;
		private System.Windows.Forms.ToolBarButton ctrlAdapters;
		private System.Windows.Forms.ToolBarButton ph0;
		private System.Windows.Forms.ToolBarButton ph1;
		private System.Windows.Forms.ToolBarButton ph2;
		private System.Windows.Forms.ToolBarButton ph3;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem miHelpMenu;
		private System.Windows.Forms.MenuItem miMonitorMenu;
		private System.Windows.Forms.MenuItem menuItem12;
		private System.Windows.Forms.Label ctrlLabel;
		private System.Windows.Forms.StatusBar ctrlStatusBar;
		private System.Windows.Forms.Panel ctrlSuperContainer;
		private System.Windows.Forms.Panel ctrlContainer;
		private System.Windows.Forms.MenuItem miViewMenu;
		private System.Windows.Forms.MenuItem miOutputWin;
		private System.Windows.Forms.MenuItem miOpen;
		private System.Windows.Forms.MenuItem miSave;
		private System.Windows.Forms.MenuItem miExit;
		private System.Windows.Forms.MenuItem miStart;
		private System.Windows.Forms.MenuItem miStop;
		private System.Windows.Forms.MenuItem miAdapters;
		private System.Windows.Forms.MenuItem miAbout;
		private System.Windows.Forms.ToolBarButton sep4;
		private System.Windows.Forms.ToolBarButton ctrlOutput;
		private System.Windows.Forms.ImageList logoImage;
		private System.Windows.Forms.ToolBarButton ctrlPause;
		private System.Windows.Forms.MenuItem miPause;
		private System.Windows.Forms.StatusBarPanel sbpRX;
		private System.Windows.Forms.StatusBarPanel sbpTX;
		private System.Windows.Forms.StatusBarPanel sbpText;
		private System.Windows.Forms.MenuItem miSettings;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem miDeleteAll;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem miRefilter;
		private System.ComponentModel.IContainer components;

		public ctrlForm()
		{
			THIS = this;

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ctrlForm));
			this.ctrlMenu = new System.Windows.Forms.MainMenu();
			this.miFileMenu = new System.Windows.Forms.MenuItem();
			this.miOpen = new System.Windows.Forms.MenuItem();
			this.miSave = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.miExit = new System.Windows.Forms.MenuItem();
			this.miMonitorMenu = new System.Windows.Forms.MenuItem();
			this.miStart = new System.Windows.Forms.MenuItem();
			this.miPause = new System.Windows.Forms.MenuItem();
			this.miStop = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.miDeleteAll = new System.Windows.Forms.MenuItem();
			this.menuItem12 = new System.Windows.Forms.MenuItem();
			this.miAdapters = new System.Windows.Forms.MenuItem();
			this.miViewMenu = new System.Windows.Forms.MenuItem();
			this.miOutputWin = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.miSettings = new System.Windows.Forms.MenuItem();
			this.miHelpMenu = new System.Windows.Forms.MenuItem();
			this.miAbout = new System.Windows.Forms.MenuItem();
			this.ctrlToolbar = new System.Windows.Forms.ToolBar();
			this.ctrlOpen = new System.Windows.Forms.ToolBarButton();
			this.ctrlSave = new System.Windows.Forms.ToolBarButton();
			this.sep1 = new System.Windows.Forms.ToolBarButton();
			this.ctrlStart = new System.Windows.Forms.ToolBarButton();
			this.ctrlPause = new System.Windows.Forms.ToolBarButton();
			this.ctrlStop = new System.Windows.Forms.ToolBarButton();
			this.ctrlAdapters = new System.Windows.Forms.ToolBarButton();
			this.sep2 = new System.Windows.Forms.ToolBarButton();
			this.ctrlOutput = new System.Windows.Forms.ToolBarButton();
			this.sep4 = new System.Windows.Forms.ToolBarButton();
			this.ph0 = new System.Windows.Forms.ToolBarButton();
			this.ph1 = new System.Windows.Forms.ToolBarButton();
			this.ph2 = new System.Windows.Forms.ToolBarButton();
			this.ph3 = new System.Windows.Forms.ToolBarButton();
			this.sep3 = new System.Windows.Forms.ToolBarButton();
			this.ctrlAbout = new System.Windows.Forms.ToolBarButton();
			this.toolbarImages = new System.Windows.Forms.ImageList(this.components);
			this.ctrlSuperContainer = new System.Windows.Forms.Panel();
			this.ctrlContainer = new System.Windows.Forms.Panel();
			this.ctrlStatusBar = new System.Windows.Forms.StatusBar();
			this.sbpText = new System.Windows.Forms.StatusBarPanel();
			this.sbpRX = new System.Windows.Forms.StatusBarPanel();
			this.sbpTX = new System.Windows.Forms.StatusBarPanel();
			this.ctrlLabel = new System.Windows.Forms.Label();
			this.logoImage = new System.Windows.Forms.ImageList(this.components);
			this.miRefilter = new System.Windows.Forms.MenuItem();
			this.ctrlSuperContainer.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.sbpText)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.sbpRX)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.sbpTX)).BeginInit();
			this.SuspendLayout();
			// 
			// ctrlMenu
			// 
			this.ctrlMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.miFileMenu,
																					 this.miMonitorMenu,
																					 this.miViewMenu,
																					 this.miHelpMenu});
			// 
			// miFileMenu
			// 
			this.miFileMenu.Index = 0;
			this.miFileMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.miOpen,
																					   this.miSave,
																					   this.menuItem5,
																					   this.miExit});
			this.miFileMenu.Text = "&File";
			// 
			// miOpen
			// 
			this.miOpen.Index = 0;
			this.miOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.miOpen.Text = "&Open...";
			this.miOpen.Click += new System.EventHandler(this.miOpen_Click);
			// 
			// miSave
			// 
			this.miSave.Index = 1;
			this.miSave.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
			this.miSave.Text = "&Save...";
			this.miSave.Click += new System.EventHandler(this.miSave_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 2;
			this.menuItem5.Text = "-";
			// 
			// miExit
			// 
			this.miExit.Index = 3;
			this.miExit.Text = "E&xit";
			this.miExit.Click += new System.EventHandler(this.miExit_Click);
			// 
			// miMonitorMenu
			// 
			this.miMonitorMenu.Index = 1;
			this.miMonitorMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						  this.miStart,
																						  this.miPause,
																						  this.miStop,
																						  this.menuItem3,
																						  this.miRefilter,
																						  this.miDeleteAll,
																						  this.menuItem12,
																						  this.miAdapters});
			this.miMonitorMenu.Text = "&Monitor";
			// 
			// miStart
			// 
			this.miStart.Index = 0;
			this.miStart.Shortcut = System.Windows.Forms.Shortcut.F5;
			this.miStart.Text = "&Start";
			this.miStart.Click += new System.EventHandler(this.miStart_Click);
			// 
			// miPause
			// 
			this.miPause.Index = 1;
			this.miPause.Shortcut = System.Windows.Forms.Shortcut.F6;
			this.miPause.Text = "&Pause";
			this.miPause.Click += new System.EventHandler(this.miPause_Click);
			// 
			// miStop
			// 
			this.miStop.Index = 2;
			this.miStop.Shortcut = System.Windows.Forms.Shortcut.F7;
			this.miStop.Text = "S&top";
			this.miStop.Click += new System.EventHandler(this.miStop_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 3;
			this.menuItem3.Text = "-";
			// 
			// miDeleteAll
			// 
			this.miDeleteAll.Index = 5;
			this.miDeleteAll.Text = "&Delete all packets";
			this.miDeleteAll.Click += new System.EventHandler(this.miDeleteAll_Click);
			// 
			// menuItem12
			// 
			this.menuItem12.Index = 6;
			this.menuItem12.Text = "-";
			// 
			// miAdapters
			// 
			this.miAdapters.Index = 7;
			this.miAdapters.Shortcut = System.Windows.Forms.Shortcut.F8;
			this.miAdapters.Text = "&Adapters...";
			this.miAdapters.Click += new System.EventHandler(this.miAdapters_Click);
			// 
			// miViewMenu
			// 
			this.miViewMenu.Index = 2;
			this.miViewMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.miOutputWin,
																					   this.menuItem1,
																					   this.miSettings});
			this.miViewMenu.Text = "&View";
			// 
			// miOutputWin
			// 
			this.miOutputWin.Index = 0;
			this.miOutputWin.Text = "&Output window...";
			this.miOutputWin.Click += new System.EventHandler(this.miOutputWin_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 1;
			this.menuItem1.Text = "-";
			// 
			// miSettings
			// 
			this.miSettings.Index = 2;
			this.miSettings.Text = "&Settings...";
			this.miSettings.Click += new System.EventHandler(this.miSettings_Click);
			// 
			// miHelpMenu
			// 
			this.miHelpMenu.Index = 3;
			this.miHelpMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.miAbout});
			this.miHelpMenu.Text = "&Help";
			// 
			// miAbout
			// 
			this.miAbout.Index = 0;
			this.miAbout.Text = "&About...";
			this.miAbout.Click += new System.EventHandler(this.miAbout_Click);
			// 
			// ctrlToolbar
			// 
			this.ctrlToolbar.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.ctrlToolbar.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						   this.ctrlOpen,
																						   this.ctrlSave,
																						   this.sep1,
																						   this.ctrlStart,
																						   this.ctrlPause,
																						   this.ctrlStop,
																						   this.ctrlAdapters,
																						   this.sep2,
																						   this.ctrlOutput,
																						   this.sep4,
																						   this.ph0,
																						   this.ph1,
																						   this.ph2,
																						   this.ph3,
																						   this.sep3,
																						   this.ctrlAbout});
			this.ctrlToolbar.ButtonSize = new System.Drawing.Size(16, 16);
			this.ctrlToolbar.DropDownArrows = true;
			this.ctrlToolbar.ImageList = this.toolbarImages;
			this.ctrlToolbar.Location = new System.Drawing.Point(0, 0);
			this.ctrlToolbar.Name = "ctrlToolbar";
			this.ctrlToolbar.ShowToolTips = true;
			this.ctrlToolbar.Size = new System.Drawing.Size(608, 28);
			this.ctrlToolbar.TabIndex = 0;
			this.ctrlToolbar.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.ctrlToolbar_ButtonClick);
			// 
			// ctrlOpen
			// 
			this.ctrlOpen.ImageIndex = 0;
			this.ctrlOpen.ToolTipText = "Open a packet dump...";
			// 
			// ctrlSave
			// 
			this.ctrlSave.ImageIndex = 1;
			this.ctrlSave.ToolTipText = "Save a packet dump...";
			// 
			// sep1
			// 
			this.sep1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// ctrlStart
			// 
			this.ctrlStart.ImageIndex = 2;
			this.ctrlStart.ToolTipText = "Hook start...";
			// 
			// ctrlPause
			// 
			this.ctrlPause.ImageIndex = 7;
			this.ctrlPause.ToolTipText = "Hook pause (no new packet will be received)...";
			// 
			// ctrlStop
			// 
			this.ctrlStop.ImageIndex = 3;
			this.ctrlStop.ToolTipText = "Stop hook...";
			// 
			// ctrlAdapters
			// 
			this.ctrlAdapters.ImageIndex = 6;
			this.ctrlAdapters.ToolTipText = "Show list of open adapters...";
			// 
			// sep2
			// 
			this.sep2.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// ctrlOutput
			// 
			this.ctrlOutput.ImageIndex = 4;
			this.ctrlOutput.ToolTipText = "Show the output window...";
			// 
			// sep4
			// 
			this.sep4.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// ph0
			// 
			this.ph0.Enabled = false;
			// 
			// ph1
			// 
			this.ph1.Enabled = false;
			// 
			// ph2
			// 
			this.ph2.Enabled = false;
			// 
			// ph3
			// 
			this.ph3.Enabled = false;
			// 
			// sep3
			// 
			this.sep3.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// ctrlAbout
			// 
			this.ctrlAbout.ImageIndex = 5;
			this.ctrlAbout.ToolTipText = "About NDIS Monitor...";
			// 
			// toolbarImages
			// 
			this.toolbarImages.ImageSize = new System.Drawing.Size(16, 16);
			this.toolbarImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("toolbarImages.ImageStream")));
			this.toolbarImages.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// ctrlSuperContainer
			// 
			this.ctrlSuperContainer.Controls.Add(this.ctrlContainer);
			this.ctrlSuperContainer.Controls.Add(this.ctrlStatusBar);
			this.ctrlSuperContainer.Controls.Add(this.ctrlLabel);
			this.ctrlSuperContainer.Dock = System.Windows.Forms.DockStyle.Fill;
			this.ctrlSuperContainer.Location = new System.Drawing.Point(0, 28);
			this.ctrlSuperContainer.Name = "ctrlSuperContainer";
			this.ctrlSuperContainer.Size = new System.Drawing.Size(608, 469);
			this.ctrlSuperContainer.TabIndex = 1;
			// 
			// ctrlContainer
			// 
			this.ctrlContainer.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ctrlContainer.Location = new System.Drawing.Point(0, 0);
			this.ctrlContainer.Name = "ctrlContainer";
			this.ctrlContainer.Size = new System.Drawing.Size(608, 447);
			this.ctrlContainer.TabIndex = 2;
			this.ctrlContainer.Visible = false;
			// 
			// ctrlStatusBar
			// 
			this.ctrlStatusBar.Location = new System.Drawing.Point(0, 447);
			this.ctrlStatusBar.Name = "ctrlStatusBar";
			this.ctrlStatusBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																							 this.sbpText,
																							 this.sbpRX,
																							 this.sbpTX});
			this.ctrlStatusBar.Size = new System.Drawing.Size(608, 22);
			this.ctrlStatusBar.TabIndex = 1;
			// 
			// sbpText
			// 
			this.sbpText.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.sbpText.Width = 260;
			// 
			// sbpRX
			// 
			this.sbpRX.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
			this.sbpRX.Icon = ((System.Drawing.Icon)(resources.GetObject("sbpRX.Icon")));
			this.sbpRX.ToolTipText = "Received packets statistics...";
			this.sbpRX.Width = 31;
			// 
			// sbpTX
			// 
			this.sbpTX.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
			this.sbpTX.Icon = ((System.Drawing.Icon)(resources.GetObject("sbpTX.Icon")));
			this.sbpTX.ToolTipText = "Sent packets statistics...";
			this.sbpTX.Width = 31;
			// 
			// ctrlLabel
			// 
			this.ctrlLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ctrlLabel.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.ctrlLabel.Location = new System.Drawing.Point(0, 0);
			this.ctrlLabel.Name = "ctrlLabel";
			this.ctrlLabel.Size = new System.Drawing.Size(608, 447);
			this.ctrlLabel.TabIndex = 0;
			this.ctrlLabel.Text = "Select an extension from the combo box above and then click on the start button.." +
				".";
			this.ctrlLabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// logoImage
			// 
			this.logoImage.ImageSize = new System.Drawing.Size(47, 25);
			this.logoImage.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("logoImage.ImageStream")));
			this.logoImage.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// miRefilter
			// 
			this.miRefilter.Index = 4;
			this.miRefilter.Text = "&Refilter...";
			this.miRefilter.Click += new System.EventHandler(this.miRefilter_Click);
			// 
			// ctrlForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(608, 497);
			this.Controls.Add(this.ctrlSuperContainer);
			this.Controls.Add(this.ctrlToolbar);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.ctrlMenu;
			this.Name = "ctrlForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "NDIS Monitor .NET 32-bit v1.00 by VitoPlantamura.COM";
			this.Load += new System.EventHandler(this.ctrlForm_Load);
			this.Closed += new System.EventHandler(this.ctrlForm_Closed);
			this.Activated += new System.EventHandler(this.ctrlForm_Activated);
			this.Deactivate += new System.EventHandler(this.ctrlForm_Deactivate);
			this.ctrlSuperContainer.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.sbpText)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.sbpRX)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.sbpTX)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new ctrlForm());
		}

		//
		// Types.
		//

		protected enum EUiState
		{
			initial = 0,
			started,
			paused
		}

		//
		// Externs.
		//

		[DllImport( "user32.dll", SetLastError = true )]
		[return: MarshalAs( UnmanagedType.Bool )]
		protected static extern bool PostMessage( IntPtr hWnd, int Msg, IntPtr wParam, IntPtr lParam );

		[DllImport( "user32.dll" )]
		static extern short GetAsyncKeyState( int vKey );

		//
		// Data.
		//

		protected static ctrlForm		THIS = null;

		protected ManualResetEvent		listenThreadExitEvent = new ManualResetEvent( false );
		protected const Int32			_nextPacketArrived = ( 0x0400 /*WM_USER*/ + 0x70 /*ARBITRARY*/ );

		protected ExtensionInfo			_sel = null;
		protected ExtensionInfo[]		_vE = null;

		protected OutputWindow			_outWin = new OutputWindow();

		protected NdisHookStubs.NT_PROTOCOL_LIST		_protocolList = null;
		protected UInt32[]								_openAdapters = null;
		protected EUiState								_uiState = EUiState.initial;

		protected ArrayList								_storedPackets = new ArrayList (); // WARNING: we must access this always from the same thread !!!
		protected int									_rxTotalBytes = 0;
		protected int									_rxTotalPackets = 0;
		protected int									_txTotalBytes = 0;
		protected int									_txTotalPackets = 0;

		protected bool									_isActivated = false;
		protected int									_escKeyCount = 0;

		//
		// Methods.
		//

		public void SubmitOutWinUserStr( string s )
		{
			if ( _sel == null )
			{
				_outWin.Add( "No extension selected." );
			}
			else
			{
				if ( _sel._instance.UserCommand( s ) == false )
				{
					_outWin.Add( "The extension refused the command." );
				}
			}
		}

		public void ExtensionLogFn( string s )
		{
			_outWin.Add( s );
		}

		protected void SetUiState( EUiState state )
		{
			this._uiState = state;

			// set the state.

			ctrlStart.Enabled =
				miStart.Enabled =
					state != EUiState.initial && state != EUiState.started;

			ctrlPause.Enabled =
				miPause.Enabled =
					state == EUiState.started;

			ctrlStop.Enabled =
				miStop.Enabled =
					state == EUiState.started;

			miRefilter.Enabled =
			miDeleteAll.Enabled =
			ctrlAdapters.Enabled =
				miAdapters.Enabled =
					state != EUiState.initial;

			switch( state )
			{
				case EUiState.initial:
					ctrlStatusBar.ShowPanels = false;
					ctrlStatusBar.Text = "Ready to capture...";
					break;

				case EUiState.started:

					ctrlStatusBar.ShowPanels = true;
					UpdateSbStats( true );
					UpdateSbStats( false );

					ctrlStatusBar.Panels[ 0 ].Text = "Capturing... (ESC to pause)";

					break;

				case EUiState.paused:
					ctrlStatusBar.ShowPanels = false;
					ctrlStatusBar.Text = "Paused.";
					break;
			}
		}

		private void ctrlForm_Load(object sender, System.EventArgs e)
		{
			// Add ourselves as a message filter.

			Application.AddMessageFilter( this );

			// Get the list of extensions.

			if ( ( _vE = GetExtensions () ) == null )
				return;

			// Create the combobox inside the toolbar. FIX: find out a better way to do this!

			ComboBox		cb = new ComboBox();
			cb.DropDownStyle = ComboBoxStyle.DropDownList;
			cb.Sorted = true;

			cb.Left = ph0.Rectangle.Left;
			cb.Width = ph3.Rectangle.Right - cb.Left;

			ctrlToolbar.Controls.Add( cb );

			// Create the toolbar logo.

			PictureBox		pb = new PictureBox();
			pb.Image = logoImage.Images[ 0 ];
			pb.SizeMode = PictureBoxSizeMode.AutoSize;
			pb.Dock = DockStyle.Right;
			pb.Cursor = Cursors.Hand;
			pb.Click += new System.EventHandler( this.ctrlVpcLogo_Click );

			ctrlToolbar.Controls.Add( pb );

			// fill the combo box.

			foreach( ExtensionInfo ei in _vE )
				cb.Items.Add( ei );

			cb.SelectionChangeCommitted += new EventHandler(cb_SelectionChangeCommitted);

			// take care of the output window.

			_outWin.MainForm = this;
			_outWin.Visible = false;

			_outWin.Add( "NDIS Monitor .NET v1.00 by VitoPlantamura.COM" );
			_outWin.Add( "=============================================" );
			_outWin.Add( "This is the output window. It can be used by extensions to log stuff. Everything entered in the edit box below will be forwarded to the currently selected extension." );
			_outWin.Add( "Waiting for the user to select an extension..." );

			// take care of the toolbar buttons status.

			SetUiState( EUiState.initial );

			// return.

			return;
		}

		private void ctrlVpcLogo_Click(object sender, System.EventArgs e)
		{
			System.Diagnostics.Process.Start( "http://www.vitoplantamura.com" );
		}

		ExtensionInfo[] GetExtensions ()
		{
			//
			// ## Get the list of extensions. ##
			//

			// get the full path.

			string		path = Path.GetDirectoryName( Application.ExecutablePath );
			if ( path[ path.Length - 1 ] != '\\' && path[ path.Length - 1 ] != '/' )
				path += "\\";
			path += "bin\\";

			// get the files list.

			string[]		files = null;

			try
			{
				files = Directory.GetFiles( path );
			}
			catch
			{
				files = null;
			}

			if ( files == null || files.Length == 0 )
			{
				MessageBox.Show( "No file was found in the \"bin\" directory located in the NDIS Monitor executable folder!\n\nIn this directory you should put at least one \"NDIS Monitor Extension DLL\" that will be used by the application for managing user interface and for handling incoming packet data!! For details on how to create such a dll module please refer to the NDIS Monitor web site at the address: \"WWW.VitoPlantamura.COM\".\n\nNDIS Monitor cannot start without at least one valid dll extension in its bin folder...", "NDIS Monitor Error" );
				Close();
				return null;
			}

			// load the assemblies.

			ArrayList		aiEI = new ArrayList ();

			foreach( string s in files )
			{
				// load.

				Assembly		a = null;

				try
				{
					a = Assembly.LoadFile( s );
				}
				catch
				{
					continue;
				}

				// iterate through the types.

				Type[]			types = a.GetTypes();
				foreach( Type t in types )
				{
					Attribute[]		vAttrs = Attribute.GetCustomAttributes( t, typeof( ExtensionAttribute ) );
					if ( vAttrs != null && vAttrs.Length == 1 )
					{
						ExtensionInfo		ei = new ExtensionInfo( ( (ExtensionAttribute) vAttrs[ 0 ] ).Name, t );
						aiEI.Add( ei );
					}
				}
			}

			if ( aiEI.Count == 0 )
			{
				MessageBox.Show( "No valid extension dll was found in the \"bin\" directory located in the NDIS Monitor executable folder!\n\nIn this directory you should put at least one \"NDIS Monitor Extension DLL\" that will be used by the application for managing user interface and for handling incoming packet data!! For details on how to create such a dll module please refer to the NDIS Monitor web site at the address: \"WWW.VitoPlantamura.COM\".\n\nNDIS Monitor cannot start without at least one valid dll extension in its bin folder...", "NDIS Monitor Error" );
				Close();
				return null;
			}

			// return.

			int					index = 0;
			ExtensionInfo[]		vE = new ExtensionInfo[ aiEI.Count ];
			foreach( object o in aiEI )
				vE[ index ++ ] = (ExtensionInfo) o;

			return vE;
		}

		protected void RemoveExtensionMenu ()
		{
			// remove.

			if ( _sel == null )
			{ // ### ASSERT ###
				if ( ctrlMenu.MenuItems[ ctrlMenu.MenuItems.Count - 1 ] != miHelpMenu ||
					ctrlMenu.MenuItems[ ctrlMenu.MenuItems.Count - 2 ] != miViewMenu )
				{
					throw new Exception( "The MainMenu must have the View and Help menus as the last popup menus !!!" );
				}
			}

			if ( ctrlMenu.MenuItems[ ctrlMenu.MenuItems.Count - 2 ] != miViewMenu )
				ctrlMenu.MenuItems.RemoveAt( ctrlMenu.MenuItems.Count - 2 );

			ctrlMenu.MenuItems[ ctrlMenu.MenuItems.Count - 1 ].Index =
				ctrlMenu.MenuItems.Count - 1; // help popup menu.
		}

		private void cb_SelectionChangeCommitted(object sender, EventArgs e)
		{
			ExtensionInfo		curr = (ExtensionInfo) ( (ComboBox) sender ).SelectedItem;
			if ( _sel == curr )
				return;

			// if an other extension was selected, call the callback.

			if ( _sel != null )
				_sel._instance.Hiding ();

			// show the new control.

			if ( curr._instance == null )
			{
				// create the control and add it to the container.

				curr._instance = (INmExtension) Activator.CreateInstance( curr._type );

				System.Windows.Forms.UserControl	c =
					(System.Windows.Forms.UserControl) curr._instance;

				ctrlContainer.Controls.Add( c );

				// set the dock properties of the control.

				c.Anchor =
					AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Top | AnchorStyles.Bottom;

				c.Left = 0;
				c.Top = 0;
				c.Width = ctrlContainer.Width;
				c.Height = ctrlContainer.Height;

				ctrlContainer.Visible = true;
			}

			// initialize the hook.

			if ( _protocolList == null )
			{
				for( int z=0; z<3; z ++ )
				{
					_protocolList = NdisHookStubs.NT_PROTOCOL_LIST.Start( (uint) PacketBacklog,
						UseLt == false ? 0 : LtLoopbackIp,
						UseLt == false ? 0 : LtNatIp );

					if ( _protocolList != null )
						break;
					else
						Thread.Sleep( 1000 );
				}

				if ( _protocolList == null )
				{
					// show a message.

					MessageBox.Show( "Unable to load the NDIS Monitor Kernel Hook Driver!\n\nThis will prevent the application from functioning properly...\n\n### WARNING ###: make sure that you are not lauching the application from a\nnetwork shared folder or from a network mapped drive.", "NDIS Monitor Error" );

					_outWin.Add( "==>> Unable to load the NDIS Monitor Kernel Hook Driver!" );
					_outWin.Add( "==>> This will prevent the application from functioning properly..." );
					_outWin.Add( "==>> WARNING: make sure that you are not lauching the application from a network shared folder or from a network mapped drive." );
				}
				else
				{
					_outWin.Add( "==>> NDIS Monitor Kernel Hook Driver loaded..." );

					// start the thread.

					Thread		listenThread = new Thread( new ThreadStart( listenThreadProc ) );
					listenThread.Start ();

					_outWin.Add( "==>> NDIS Monitor listen thread started..." );
				}
			}

			// print a msg in the output win.

			_outWin.Add( "" );
			string		txt = "Activating the \"" + curr._name + "\" extension...";
			_outWin.Add( txt );
			string		spc = "";
			for( int x=0; x<txt.Length; x ++ )
				spc += "=";
			_outWin.Add( spc );

			// inform the extension that we are showing it.

			RemoveExtensionMenu ();

			MenuItem			popupMenu = new MenuItem ();
			int					popupMenuIndex = ctrlMenu.MenuItems.Count - 1;

			popupMenu.Index = popupMenuIndex;
			popupMenu.Text = "E&xtension";

			curr._instance.Showing ( new LogFn( ExtensionLogFn ), _protocolList, popupMenu );
			( (System.Windows.Forms.UserControl) curr._instance ).Visible = true;

			if ( popupMenu.MenuItems.Count != 0 )
				ctrlMenu.MenuItems.Add( popupMenuIndex, popupMenu );

			ctrlMenu.MenuItems[ ctrlMenu.MenuItems.Count - 1 ].Index =
				ctrlMenu.MenuItems.Count - 1; // help popup menu.

			// take care of the already shown control.

			if ( _sel == null )
				ctrlLabel.Visible = false;
			else
				( (System.Windows.Forms.UserControl) _sel._instance ).Visible = false;

			// Update the UI.

			if ( _protocolList != null && _uiState != EUiState.paused )
				SetUiState( EUiState.started );

			bool		showAdapters = false;
			if ( _sel == null )
				showAdapters = true;

			// Set the selection var and log the change.

			_sel = curr;

			// show the adapters dlg.

			if ( showAdapters && _protocolList != null )
				miAdapters_Click( null, null );

			// return.

			return;
		}

		protected void listenThreadProc ()
		{
			// check out the "protocol list" pointer.

			if ( THIS._protocolList == null )
				return;

			// get the next packet.

			ArrayList		al = new ArrayList ();

			while( true )
			{
				bool			clearAl = true;

				NdisHookStubs.NEXT_PACKET		np = NdisHookStubs.NEXT_PACKET.WaitFor ();

				if ( np == null && THIS._protocolList == null )
				{
					break;
				}
				else if ( np != null )
				{
					if ( THIS._uiState == EUiState.paused )
					{
						// destroy packet...

						np.Destroy ();
					}
					else
					{
						// check whether clearing the AL is required and process the packet.

						al.Add( np );

						if ( np._hsStats.bArePacketsRemaining != 0 )
						{
							// delay post.
							clearAl = false;
						}
						else
						{
							// order by packet serial number (patch_VP_28may2005).
							// we need to do this here, because some requests may be handled by the system directly at higher IRQL levels,
							//  so we may receive the related packets in a wrong order.
							for ( int i=0; i<al.Count; i ++ )
							{
								NdisHookStubs.NEXT_PACKET		npI = (NdisHookStubs.NEXT_PACKET) al[ i ];
								int								k = i;
								for ( int j=i+1; j<al.Count; j ++ )
									if ( ((NdisHookStubs.NEXT_PACKET)al[ j ])._dwPacketSerial < npI._dwPacketSerial )
										k = j;
								if ( k != i )
								{
									al[ i ] = al[ k ];
									al[ k ] = npI;
								}
							}

							// post the packets in the correct thread context.
							foreach( NdisHookStubs.NEXT_PACKET thisNp in al )
							{
								IntPtr			ptr = (IntPtr) thisNp;
								PostMessage( THIS.Handle, _nextPacketArrived, new IntPtr( 0 ), ptr ); // old tricks die hard... !
							}
						}
					}
				}

				if ( clearAl )
					al.Clear ();
			}

			// return.

			listenThreadExitEvent.Set ();
			return;
		}

		protected void UpdateSbStats( NdisHookStubs.NEXT_PACKET np )
		{
			// update sb.

			if ( ctrlStatusBar.ShowPanels )
			{
				if ( np._bDirection == 0 ) // RX
				{
					_rxTotalBytes += np._data.GetLength( 0 );
					_rxTotalPackets ++;
				}
				else // TX
				{
					_txTotalBytes += np._data.GetLength( 0 );
					_txTotalPackets ++;
				}

				UpdateSbStats( np._bDirection == 0 );
			}
		}

		protected override void WndProc( ref Message m )
		{
			switch( m.Msg )
			{
				case _nextPacketArrived:

					//
					// # get the packet and forward it in the correct thread context... #
					//

					NdisHookStubs.NEXT_PACKET		np = (NdisHookStubs.NEXT_PACKET) m.LParam;

					// update status bar and ui.

					UpdateSbStats( np );

					// forward to correct extension and save.

					bool		res = false;

					StoredPacket		sp = new StoredPacket();
					sp._rp = RawPacket.GET( np._data );
					sp._np = np;
					sp._ord = _storedPackets.Count;

					if ( _sel != null && _sel._instance != null )
						res = _sel._instance.ProcessNextPacket( sp._rp, sp._np, sp._ord, sp._tm );

					sp._accepted = res;

					_storedPackets.Add( sp );

					//
					// # Check the ESC key. #
					//

					if ( ( GetAsyncKeyState( /*VK_ESCAPE*/ 0x1B ) & 0x8000 ) != 0 )
					{
						if ( _uiState == EUiState.started &&
							( _isActivated == true || _escKeyCount > 150 ) )
						{
							// reset counter.
							_escKeyCount = 0;

							// pause.
							miPause_Click( null, null );

							// show dlg.
							CapturePausedDlg		dlg = new CapturePausedDlg ();
							dlg.ShowDialog ();
						}
						else
						{
							// increment counter.
							_escKeyCount ++;
						}
					}
					else
					{
						// reset counter.
						_escKeyCount = 0;
					}

					//
					// # exit. #
					//

					break;

				default:
					base.WndProc( ref m );
					break;
			}
		}

		bool IMessageFilter.PreFilterMessage( ref Message m )
		{
			switch( m.Msg )
			{
				case /*WM_KEYDOWN*/ 0x0100:

					// check whether it is the ESCAPE key.
					if ( m.WParam == new IntPtr( /*VK_ESCAPE*/ 0x1B ) &&
						_uiState == EUiState.started &&
						_isActivated == true )
					{
						// pause.
						miPause_Click( null, null );

						// show dlg.
						CapturePausedDlg		dlg = new CapturePausedDlg ();
						dlg.ShowDialog ();
					}

					// process the message.
					return false;

				default:

					// process the message.
					return false;
			}
		}

		protected void UpdateSbStats( bool rx )
		{
			if ( rx )
				ctrlStatusBar.Panels[ 1 ].Text = "RX = " + _rxTotalPackets.ToString() + " (" + _rxTotalBytes.ToString() + " bytes)";
			else
				ctrlStatusBar.Panels[ 2 ].Text = "TX = " + _txTotalPackets.ToString() + " (" + _txTotalBytes.ToString() + " bytes)";
		}

		private void miOutputWin_Click(object sender, System.EventArgs e)
		{
			// show

			_outWin.Visible = true;
			_outWin.Focus ();
		}

		private void ctrlToolbar_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			// switch.

			if ( e.Button == ctrlAdapters )
			{
				miAdapters_Click( null, null );
				return;
			}
			else if ( e.Button == ctrlAbout )
			{
				miAbout_Click( null, null );
				return;
			}
			else if ( e.Button == ctrlOutput )
			{
				miOutputWin_Click( null, null );
				return;
			}
			else if ( e.Button == ctrlPause )
			{
				miPause_Click( null, null );
				return;
			}
			else if ( e.Button == ctrlSave )
			{
				miSave_Click( null, null );
				return;
			}
			else if ( e.Button == ctrlOpen )
			{
				miOpen_Click( null, null );
				return;
			}
			else if ( e.Button == ctrlStop )
			{
				miStop_Click( null, null );
				return;
			}
			else if ( e.Button == ctrlStart )
			{
				miStart_Click( null, null );
				return;
			}

			// return.

			return;
		}

		private void miAbout_Click(object sender, System.EventArgs e)
		{
			AboutBox			dlg = new AboutBox ();
			dlg.ShowDialog ();
		}

		private void miExit_Click(object sender, System.EventArgs e)
		{
			Close ();
		}

		private void miAdapters_Click(object sender, System.EventArgs e)
		{
			OpenAdapters		dlg = new OpenAdapters ();
			dlg.SetProtList( _protocolList, _openAdapters );
			dlg.ShowDialog ();

			if ( dlg._retval != null && _protocolList != null )
			{
				_openAdapters = dlg._retval;
				_protocolList.Listen( _openAdapters );
			}
		}

		private void ctrlForm_Closed(object sender, System.EventArgs e)
		{
			//
			// CLEAN UP !!!
			//

			StopCapturing ();
		}

		protected void DeleteAllPackets ( bool destroyNextPackets )
		{
			// alert extensions.

			foreach( ExtensionInfo e in _vE )
				if ( e._instance != null )
				{
					e._instance.DeleteAllPackets ();
				}

			// free packets.

			if ( destroyNextPackets )
				foreach( StoredPacket sp in _storedPackets )
					sp._np.Destroy ();

			_storedPackets.Clear ();

			// return.

			return;
		}

		protected void StopCapturing ()
		{
			//
			// # clean up. #
			//

			// alert extensions.

			foreach( ExtensionInfo e in _vE )
				if ( e._instance != null )
				{
					e._instance.Disposing ();
					e._instance = null;
				}

			// stop hook.

			if ( _protocolList != null )
			{
				listenThreadExitEvent.Reset ();

				NdisHookStubs.NT_PROTOCOL_LIST		pl = _protocolList;
				_protocolList = null;
				_openAdapters = null;
				pl.Stop ();

				listenThreadExitEvent.WaitOne ( 1000, false );
			}

			// free packets.

			foreach( StoredPacket sp in _storedPackets )
				sp._np.Destroy ();

			_storedPackets.Clear ();

			// reset statistics.

			_rxTotalBytes = 0;
			_rxTotalPackets = 0;
			_txTotalBytes = 0;
			_txTotalPackets = 0;

			// reset combo box.

			ComboBox			cb = null;
			foreach( Control c in ctrlToolbar.Controls )
				if ( c is ComboBox )
				{
					cb = (ComboBox) c;
					break;
				}
			if ( cb == null ) // ### ASSERT ###
				throw new Exception( "ASSERT: StopCapturing: cb == null." );

			cb.Items.Clear ();
			foreach( ExtensionInfo ei in _vE )
				cb.Items.Add( ei );

			// reset ui.

			RemoveExtensionMenu ();

			_sel = null;

			ctrlLabel.Visible = true;

			ctrlContainer.Controls.Clear ();
			ctrlContainer.Visible = false;

			SetUiState( EUiState.initial );

			// return.

			return;
		}

		private void miPause_Click(object sender, System.EventArgs e)
		{
			SetUiState( EUiState.paused );
			return;
		}

		private void miSettings_Click(object sender, System.EventArgs e)
		{
			SettingsWindow			dlg = new SettingsWindow ();
			dlg.ShowDialog ();
		}

		public const int PacketBacklog_DefValue = 32;
		public const int PacketBacklog_MinValue = 16;
		public const int PacketBacklog_MaxValue = 256;

		private void miSave_Click(object sender, System.EventArgs e)
		{
			// show the dialog (s).

			if ( _uiState != EUiState.started && _uiState != EUiState.paused )
			{
				MessageBox.Show( "The capture must be in the started or paused state in order to save the packet contents.", "NDIS Monitor" );
				return;
			}

			SaveActionDialog			dlg = new SaveActionDialog ();
			dlg.ShowDialog ();

			if ( dlg._saveAction == -1 )
				return;

			SaveFileDialog				save = new SaveFileDialog ();
			save.Filter = "NDIS Monitor Packet Capture Files (*.nmc)|*.nmc";
			save.FilterIndex = 0;
			save.RestoreDirectory = true;

			if ( save.ShowDialog () != DialogResult.OK )
				return;

			// Save the dump.

			int					count = 0;
			FileStream			fs = null;
			BinaryWriter		bw = null;

			try
			{
				fs = new FileStream( save.FileName, FileMode.Create, FileAccess.Write );
				bw = new BinaryWriter( fs );
				StoredPacket.WriteIdHeaderInStream( bw );

				foreach( StoredPacket sp in _storedPackets )
				{
					if ( sp._accepted == false && dlg._saveAction == 0 )
						continue;
					sp.SaveInStream( bw );
					count ++;
				}
			}
			catch( Exception ex )
			{
				count = 0;
				MessageBox.Show( "Error when writing file: \"" + ex.Message + "\"", "NDIS Monitor" );
			}
			finally
			{
				if ( fs != null )
					fs.Close ();
				if ( bw != null )
					bw.Close ();
			}

			// show a dialog.

			MessageBox.Show( count.ToString() + " packet(s) saved.", "NDIS Monitor" );
		}

		private void miOpen_Click(object sender, System.EventArgs e)
		{
			// show the dlgs.

			if ( _uiState != EUiState.started && _uiState != EUiState.paused )
			{
				MessageBox.Show( "The capture must be in the started or paused state in order to load packets from a .NMC file.\r\n\r\nThe packets will be forwarded to the selected extension as if they are fetched from the kernel driver. You can deselect all the adapters in the Adapters window if you want to avoid any interference with the kernel driver dump.", "NDIS Monitor" );
				return;
			}

			OpenFileDialog			open = new OpenFileDialog ();
			open.Filter = "NDIS Monitor Packet Capture Files (*.nmc)|*.nmc";
			open.FilterIndex = 0;
			open.RestoreDirectory = true;

			if ( open.ShowDialog () != DialogResult.OK )
				return;

			// load the file.

			int				count = 0;
			FileStream		fs = null;
			BinaryReader	br = null;

			try
			{
				fs = new FileStream( open.FileName, FileMode.Open, FileAccess.Read );
				br = new BinaryReader( fs );
				StoredPacket.ReadIdHeaderFromStream( br );

				while( true )
				{
					// get the packet.

					StoredPacket			sp = StoredPacket.ReadFromStream( br );
					if ( sp == null )
						break;
					count ++;

					// update ui.

					UpdateSbStats( sp._np );

					// forward it.

					sp._ord = _storedPackets.Count;

					bool		res = false;
					if ( _sel != null && _sel._instance != null )
						res = _sel._instance.ProcessNextPacket( sp._rp, sp._np, sp._ord, sp._tm );

					sp._accepted = res;

					_storedPackets.Add( sp );
				}
			}
			catch( Exception ex )
			{
				count = 0;
				MessageBox.Show( "Error when reading from file: \"" + ex.Message + "\"", "NDIS Monitor" );
			}
			finally
			{
				if ( fs != null )
					fs.Close ();
				if ( br != null )
					br.Close ();
			}

			// show a dialog.

			MessageBox.Show( count.ToString() + " packet(s) read.", "NDIS Monitor" );
		}

		private void miStop_Click(object sender, System.EventArgs e)
		{
			if ( _uiState != EUiState.started && _uiState != EUiState.paused ) // ### ASSERT ###
				throw new Exception( "ASSERT: Stop_Click: _uiState != EUiState.started && _uiState != EUiState.paused" );

			// show a dlg.

			if ( MessageBox.Show( "Are you sure you want to stop capturing?\r\n\r\nThis will make the application free the captured packets and reset the initialized extensions. Maybe you want simply to pause the capture through the Pause key in the toolbar. Do you want to stop capturing anyway ?", "NDIS Monitor", MessageBoxButtons.YesNo ) == DialogResult.No )
				return;

			// stop capturing.

			StopCapturing ();

			// return.

			return;
		}

		private void miStart_Click(object sender, System.EventArgs e)
		{
			if ( _uiState != EUiState.paused )
				throw new Exception( "ASSERT: Start_Click: uiState != EUiState.paused" );

			// Restore capturing.

			SetUiState( EUiState.started );
			return;
		}

		private void ctrlForm_Activated(object sender, System.EventArgs e)
		{
			_isActivated = true;
		}

		private void ctrlForm_Deactivate(object sender, System.EventArgs e)
		{
			_isActivated = false;
		}

		public static int PacketBacklog
		{
			get
			{
				try
				{
					object		v = Application.UserAppDataRegistry.GetValue( "PacketBacklog" );
					if ( v == null || ( v is string ) == false )
						return PacketBacklog_DefValue;

					int			i = Convert.ToInt32( v as string );
					if ( i < PacketBacklog_MinValue )
						return PacketBacklog_DefValue;
					else if ( i > PacketBacklog_MaxValue )
						return PacketBacklog_DefValue;
					return i;
				}
				catch
				{
					return PacketBacklog_DefValue;
				}
			}
			set
			{
				if ( value < PacketBacklog_MinValue )
					throw new Exception( "value < PacketBacklog_MinValue" );
				else if ( value > PacketBacklog_MaxValue )
					throw new Exception( "value > PacketBacklog_MaxValue" );

				Application.UserAppDataRegistry.SetValue( "PacketBacklog", value.ToString () );
			}
		}

		public const uint LtLoopbackIp_DefValue = 0xA9FE1981;

		public static uint LtLoopbackIp
		{
			get
			{
				object			o = Application.UserAppDataRegistry.GetValue( "LtLoopbackIp" );
				if ( o == null || ( o is string ) == false )
					return LtLoopbackIp_DefValue;
				try
				{
					return Convert.ToUInt32( (string) o );
				}
				catch
				{
					return LtLoopbackIp_DefValue;
				}
			}
			set
			{
				Application.UserAppDataRegistry.SetValue( "LtLoopbackIp", value.ToString () );
			}
		}

		public static uint GenerateLtNatIp( uint loopbackIp )
		{
			if ( ( loopbackIp & 0xFF ) > 0x00 )
				return loopbackIp - 1;
			else
				return loopbackIp + 1;
		}

		private void miDeleteAll_Click(object sender, System.EventArgs e)
		{
			// delete all the packets...

			if ( _uiState == EUiState.initial ) // ### ASSERT ###
				throw new Exception( "ASSERT: DeleteAll_Click: state == EUiState.initial" );

			// show a dlg.

			if ( MessageBox.Show( "Are you sure ?", "NDIS Monitor", MessageBoxButtons.YesNo ) == DialogResult.No )
				return;

			// delete all the packets.

			DeleteAllPackets ( true );

			// return.

			return;
		}

		private void miRefilter_Click(object sender, System.EventArgs e)
		{
			// assert.

			if ( _uiState == EUiState.initial ) // ### ASSERT ###
				throw new Exception( "ASSERT: Refilter_Click: state == EUiState.initial" );

			// show a dialog.

			if ( MessageBox.Show( "The REFILTER function is equivalent to the following actions acted in this exact order:\n\n(1) SAVE of the packet dump.\n(2) DELETE ALL PACKETS.\n(3) OPEN of the previous packet dump.\n\nThis special function is required when there is the need to apply a new filter logic to the currently displayed packet set. A filter logic can be expressed by the means of C# code: to specify a new filter for network packets, select the \"Standard\" extension plugin from the combo box and click on the Extension->Code Window option in the application menu.\n\nDo you want to continue with REFILTER ?", "NDIS Monitor", MessageBoxButtons.YesNo ) == DialogResult.No )
				return;

			// apply REFILTER.

			ArrayList		al = new ArrayList ();
			foreach( StoredPacket sp in _storedPackets )
				al.Add( sp );

			DeleteAllPackets( false );

			int			filtin = 0, filtout = 0;

			foreach( StoredPacket sp in al )
			{
				// add to the collection.

				sp._ord = _storedPackets.Count;

				bool		res = false;
				if ( _sel != null && _sel._instance != null )
					res = _sel._instance.ProcessNextPacket( sp._rp, sp._np, sp._ord, sp._tm );

				sp._accepted = res;

				if ( res )
					filtin ++;
				else
					filtout ++;

				_storedPackets.Add( sp );
			}

			MessageBox.Show( "Packets:\n\nFiltered IN: " + filtin.ToString () + ".\nFiltered OUT: " + filtout.ToString () + ".", "REFILTER Results" );

			// return.

			return;
		}

		public static uint LtNatIp
		{
			get
			{
				uint			loopbackIp = LtLoopbackIp;
				return GenerateLtNatIp( loopbackIp );
			}
		}

		public static bool UseLt
		{
			get
			{
				object		o = Application.UserAppDataRegistry.GetValue( "UseLt" );
				if ( o == null || ( o is string ) == false )
					return false;
				try
				{
					return Convert.ToInt32( (string) o ) == 0 ? false : true;
				}
				catch
				{
					return false;
				}
			}
			set
			{
				Application.UserAppDataRegistry.SetValue( "UseLt", value == true ? 1.ToString() : 0.ToString() );
			}
		}
	}

	public class ExtensionInfo
	{
		//
		// Construction.
		//

		public ExtensionInfo ( string name, Type type )
		{
			this._name = name;
			this._type = type;
		}

		//
		// Data.
		//

		public string			_name;
		public Type				_type;
		public INmExtension		_instance = null;

		//
		// Methods.
		//

		public override string ToString()
		{
			return _name;
		}
	}

	internal class StoredPacket
	{
		// # data. #

		public RawPacket						_rp = null;
		public NdisHookStubs.NEXT_PACKET		_np = null;
		public int								_ord = 0;
		public DateTime							_tm = DateTime.Now;

		public bool								_accepted = false;

		// # methods #

		protected const UInt32					_headerTag = 0x30434D4E; // 'NMC0'
		protected const UInt32					_packetTag = 0x30544350; // 'PCT0'

		public static void WriteIdHeaderInStream( BinaryWriter w )
		{
			w.Write( (uint) _headerTag );
		}

		public static void ReadIdHeaderFromStream( BinaryReader r )
		{
			if ( r.ReadUInt32() != _headerTag )
				throw new Exception( "Invalid format ('NMC0' tag not found.)" );
		}

		public void SaveInStream( BinaryWriter w )
		{
			w.Write( _packetTag );

			w.Write( _ord );
			w.Write( (Int64) _tm.ToUniversalTime().ToFileTime () );

			_np.Serialize( w );
		}

		public static StoredPacket ReadFromStream( BinaryReader r )
		{
			// eof check.

			if ( r.BaseStream.Length == r.BaseStream.Position )
				return null;

			// read.

			if ( r.ReadUInt32() != _packetTag )
				throw new Exception( "Invalid packet format ('PCT0' tag not found.)" );

			int			ord = r.ReadInt32 ();
			DateTime	tm = DateTime.FromFileTime( (long) r.ReadInt64() ).ToLocalTime();

			NdisHookStubs.NEXT_PACKET		np = NdisHookStubs.NEXT_PACKET.Deserialize( r );

			// return.

			StoredPacket			retVal = new StoredPacket ();
			retVal._rp = RawPacket.GET( np._data );
			retVal._np = np;
			retVal._ord = ord;
			retVal._tm = tm;

			return retVal;
		}
	}
}
